
#ifndef SERVER_H
#define SERVER_H

#include <time.h>

class Server
{
public:
	Server(int socket);
	~Server();
	static int getActiveServersNum() { return activeServersNum; }
	static int getWriterPercent() { return writerPercent; }
	static int getWriterStatus() { return writerStatus; }
	static void initStatic();
	static void initStatic2();
	void run();
	static void terminate();
	int waitForService(class Queue *queue, int toRank);
private:
	void burnSession(char *cmdStr);
	void eject();
	void errorToClient(const char *format, ...);
	void executeCmd();
	const char *getNewLogFileName(char *str);
	void load();
	void logConnection();
	void logSession(const char *typeStr, const char *resultStr);
	int nextCmd();
	int noDisc();
	void readATIP();
	void readTOC();
	void run_cdrecord(int multiTOC);
	void run_mkisofs();
	void showWaitForDiscMsg();
	void successToClient(const char *format, ...);
	void toClient(const char *type, const char *format, ...);
	int waitForDisc();

	static int activeServersNum;
	static int nextServerNo;
	static class Queue *writerQueue;
	static int writerStatus, writerPercent;
	static int mp3Support;

	int serverNo;
	time_t connectionT0, sessionT0, sessionT1, burnT0;
	int sock;
	FILE *inStream;
	char lineStr[1024];
	int logFilesNum;

	// states
	int bytesReceived;
	static int configError;
	int openCommands, isOffline;
	const char
		*clientSystemName, *clientSystemVersion,
		*clientUserID, *clientUserName,
		*userID, *userPassword, *userID2;

	// modes
	int
		modeBurnOffline, modeLaserOff,
		modeShowCdrecord, modeShowMkisofs,
		modeSpeed;

	class Session *session;
	struct CDR {
		int isBlank;
		int valid;
		int extentsWrittenKB, isMultiSession;
		int totalKB, oldFreeKB, newFreeKB;
		CDR()
		{
			isBlank = 0;
			valid = 0;
			extentsWrittenKB = 0;
		}
		void scan(const char *str)
		{
			int a, b, c;
			if (sscanf(str, "Blocks total: %d "
				"Blocks current: %d "
				"Blocks remaining: %d",
				&a, &b, &c) != 3)
				return;
			valid = 1;
			totalKB = 2 * a;
			oldFreeKB = 2 * b;
			newFreeKB = 2 * c - 22 * 1024;
			if (!isMultiSession || newFreeKB < 0)
				newFreeKB = 0;
		}
		int sessionSize()
		{
			return oldFreeKB - newFreeKB;
		}
	} CD;
	int quit;
};

#endif

