
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;

/**
  * This is a dialog which allows users to choose preferences
  *
  * @version 0.1 09/30/99
  * @author Jrg Haeger
  */
public class OptionsDialog extends JDialog
{
	public OptionsDialog()
	{
		super(CDcreator.mainWin, i18n("titleOptions"), true);

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				cancelPressed();
			}
		});

		JPanel selectionPanel = new JPanel()
		{
			public Insets getInsets() {
				return new Insets(10, 10, 10, 10);
			}
		};
		selectionPanel.setLayout(
			new BoxLayout(selectionPanel, BoxLayout.Y_AXIS));

/*		JPanel p = new JPanel();
		p.setLayout(
			new BoxLayout(p, BoxLayout.X_AXIS));
*/
		Box p = Box.createHorizontalBox();
		p.add(new JLabel(i18n("speed")));
		p.add(Box.createHorizontalStrut(40));
		String[] speeds = { "2x", "4x", "6x", "8x" };
		speedBox = new JComboBox(speeds);
		speedBox.setSelectedIndex(1);
		speedBox.setToolTipText(i18n("TTspeedBox"));
//		p.add(speedBox);
//		selectionPanel.add(p);

		JPanel b = new JPanel();
		b.setLayout(
			new BoxLayout(b, BoxLayout.Y_AXIS));
		b.setBorder(BorderFactory.createTitledBorder(
			BorderFactory.createLineBorder(Color.black),
			i18n("burnGroup")));
		b.add(new JLabel(i18n("Speed")));
		b.add(speedBox);
		b.add(Box.createVerticalStrut(10));
		testModeBox = new JCheckBox(
			i18n("laserOff"), false);
		b.add(testModeBox);
		selectionPanel.add(b);

		offlineBox = new JCheckBox(
			i18n("burnOffline"), false);
		offlineBox.setToolTipText(i18n("TTofflineBox"));
		selectionPanel.add(offlineBox);

		logBox = new JCheckBox(
			i18n("showProtocolWin"), false);
		logBox.setToolTipText(i18n("TTlogBox"));
		selectionPanel.add(logBox);

		getContentPane().add(
			selectionPanel,	BorderLayout.CENTER);

		JPanel panel = new JPanel();
		panel.setLayout(new FlowLayout());

		JButton cancel = new JButton(i18n("cancel"));
		cancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cancelPressed();
			}
		});
		panel.add(cancel);

		JButton ok = new JButton(i18n("continue"));
		ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				OKPressed();
			}
		});
		panel.add(ok);

		getContentPane().add(panel, BorderLayout.SOUTH);
//		pack();
		canceled = false;
	}

	public void cancelPressed()
	{
		canceled = true;
		this.setVisible(false);
	}

	public boolean protocol()
	{
		return logBox.isSelected();
	}

	public boolean getOfflineMode()
	{
		return offlineBox.isSelected();
	}

	public int getSpeed()
	{
		try {
			StreamTokenizer tokenizer
			= new StreamTokenizer(
				new StringReader(
				(String)speedBox.getSelectedItem()));

		if (tokenizer.nextToken() != StreamTokenizer.TT_NUMBER)
			return 1;
		else
			return (int)tokenizer.nval;
		} catch (Exception e)
		{
			return 1;
		}
	}

	public boolean getTestMode()
	{
		return testModeBox.isSelected();
	}

	static String i18n(String str)
	{
		return CDcreator.i18n(str);
	}

	public void OKPressed()
	{
		this.setVisible(false);
	}

	public boolean wasCanceled()
	{
		return canceled;
	}

	JCheckBox logBox, offlineBox, testModeBox;
	JComboBox speedBox;
	boolean canceled;
}

